Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::mfrotation Class Reference

A rotation array node field value. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::mfrotation:
[legend]

List of all members.

## Public Types

typedef std::vector< rotation > | value_type
| Type of value.

## Public Member Functions

| mfrotation (std::vector< rotation >::size_type n=0, const rotation &value=rotation()) throw ( std::bad_alloc )
| Construct.
| mfrotation (const value_type &value) throw ( std::bad_alloc )
| Construct.
| mfrotation (const mfrotation &mfr)
| Construct a copy.
virtual | ~mfrotation () throw ()
| Destroy.
mfrotation & | operator= (const mfrotation &mfr) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (mfrotation &mfr) throw ()
| Swap.

## Static Public Attributes

static const type_id | field_value_type_id = mfrotation_id
| `field_value::type_id` for this class.

## Private Member Functions

virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual mfrotation & | do_assign (const field_value &value) throw ( std::bad_cast , std::bad_alloc )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the `field_value::type_id` associated with this class.
virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfrotation &lhs, const mfrotation &rhs) throw()
| Compare for equality.
bool | operator!= (const mfrotation &lhs, const mfrotation &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfrotation &a, openvrml::mfrotation &b)
| Swap the values of `a` and `b`.

## Detailed Description

A rotation array node field value.

Model of
  Field Value

## Member Typedef Documentation

openvrml::mfrotation::value_type

Type of value.

## Constructor & Destructor Documentation

openvrml::mfrotation::mfrotation | ( | std::vector< rotation >::size_type | n = `0`,
|  | const rotation & | value = `rotation()` |
| ) |  |  | throw ( std::bad_alloc )`[explicit]`

Construct.

Creates an `mfrotation` with `n` copies of `value`.

Parameters:

  `[in]` | n | the number elements in the `mfrotation`.
  `[in]` | value | used to initialize the `mfrotation`.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Postcondition:
  size is `n`. Every element is a copy of `value`.

openvrml::mfrotation::mfrotation | ( | const value_type & | value | ) | throw ( std::bad_alloc )`[inline, explicit]`

Construct.

Parameters:

  `[in]` | value | initial value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

openvrml::mfrotation::mfrotation | ( | const mfrotation & | mfr | ) |

Construct a copy.

Parameters:

  `[in]` | mfr | the instance to copy.

openvrml::mfrotation::~mfrotation | ( |  | ) | throw ()`[virtual]`

Destroy.

Each of the `mfrotation`'s value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

openvrml::mfrotation & openvrml::mfrotation::operator= | ( | const mfrotation & | mfr | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  `[in]` | mfr | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

const openvrml::mfrotation::value_type & openvrml::mfrotation::value | ( |  | ) | const throw ()

Access.

Returns:
  the rotation values.

Reimplemented from openvrml::field_value.

void openvrml::mfrotation::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  `[in]` | val | the new value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

void openvrml::mfrotation::swap | ( | mfrotation & | mfr | ) | throw ()

Swap.

Parameters:

  `[in,out]` | mfr | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::mfrotation::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::mfrotation & openvrml::mfrotation::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast , std::bad_alloc )`[private, virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an mfrotation object.
  | std::bad_alloc | if memory allocation fails.

openvrml::field_value::type_id openvrml::mfrotation::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the `field_value::type_id` associated with this class.

Returns:
  `field_value::mfrotation_id`.

Implements openvrml::field_value.

void openvrml::mfrotation::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  `[in,out]` | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfrotation & | lhs,
|  | const mfrotation & | rhs |
| ) |  |  | throw()`[related]`

Compare for equality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfrotation & | lhs,
|  | const mfrotation & | rhs |
| ) |  |  | throw()`[related]`

Compare for inequality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfrotation & | a,
|  | openvrml::mfrotation & | b |
| ) |  |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  `[in,out]` | a |
  `[in,out]` | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::mfrotation::field_value_type_id = mfrotation_id`[static]`

`field_value::type_id` for this class.